Summary: MPI Benchmarks and tests
Name: mpitests
Version: 3.0
Release: 2%{?dist}
License: BSD
Group: Applications
Source: mpitests-%{version}.tar.gz
Patch0: mpitests-2.0-make.patch
Provides: mpitests
BuildRoot: /var/tmp/%{name}-%{version}-%{release}-root
# mvapich2 only exists on these three arches
ExclusiveArch: i386 x86_64 ia64

%description
Set of popular MPI benchmarks:
IMB-2.3
Presta-1.4.0
OSU benchmarks ver 2.2

%package openmpi
Summary: MPI tests package compiled against openmpi
Group: Applications
BuildRequires: openmpi, openmpi-devel
%description openmpi
MPI test suite compiled against the openmpi package

%package mvapich
Summary: MPI tests package compiled against mvapich
Group: Applications
BuildRequires: mvapich, libibverbs-devel, libibumad-devel, libibcommon-devel
%description mvapich
MPI test suite compiled against the mvapich package

%package mvapich2
Summary: MPI tests package compiled against mvapich2
Group: Applications
BuildRequires: mvapich2, libibverbs-devel, libibumad-devel, libibcommon-devel
BuildRequires: librdmacm-devel
%description mvapich2
MPI test suite compiled against the mvapich2 package

%prep
%setup -q
%patch0 -p1 -b .make

%build
# Have to build in the install step

%install
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-Wp,-D_FORTIFY_SOURCE=.//' | sed -e 's/-fstack-protector//'`
# do three builds, one for each mpi stack
OLD_PATH="$PATH"
OLD_LD_PATH="$LD_CONFIG_PATH"
VERSION=`rpm -q --queryformat="%%{version}\n" openmpi.%{_arch} | head -1`
MPI_BIN=%{_libdir}/openmpi/$VERSION-gcc/bin
MPI_LIB=%{_libdir}/openmpi/$VERSION-gcc/lib
PATH=$MPI_BIN:$OLD_PATH
LD_CONFIG_PATH=$MPI_LIB:$OLD_LD_PATH
make CC=mpicc CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" all
mkdir -p %{buildroot}$MPI_BIN
make DESTDIR=%{buildroot} INSTALL_DIR=$MPI_BIN install
make clean
VERSION=`rpm -q --queryformat="%%{version}\n" mvapich.%{_arch} | head -1`
MPI_BIN=%{_libdir}/mvapich/$VERSION-gcc/bin
MPI_LIB=%{_libdir}/mvapich/$VERSION-gcc/lib
PATH=$MPI_BIN:$OLD_PATH
LD_CONFIG_PATH=$MPI_LIB:$OLD_LD_PATH
# mvapich is an MPI-1 level implementation and doesn't do many of the benchmarks
make CC=mpicc CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" osu-mpi1 presta
mkdir -p %{buildroot}$MPI_BIN
make DESTDIR=%{buildroot} INSTALL_DIR=$MPI_BIN install-osu install-presta
make clean
VERSION=`rpm -q --queryformat="%%{version}\n" mvapich2.%{_arch} | head -1`
MPI_BIN=%{_libdir}/mvapich2/$VERSION-gcc/bin
MPI_LIB=%{_libdir}/mvapich2/$VERSION-gcc/lib
PATH=$MPI_BIN:$OLD_PATH
LD_CONFIG_PATH=$MPI_LIB:$OLD_LD_PATH
make CC=mpicc CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" all
mkdir -p %{buildroot}$MPI_BIN
make DESTDIR=%{buildroot} INSTALL_DIR=$MPI_BIN install

%clean
rm -rf %{buildroot}

%files openmpi
%defattr(-, root, root, -)
%{_libdir}/openmpi/*/bin/*

%files mvapich
%defattr(-, root, root, -)
%{_libdir}/mvapich/*/bin/*

%files mvapich2
%defattr(-, root, root, -)
%{_libdir}/mvapich2/*/bin/*

%changelog
* Thu Sep 18 2008 Doug Ledford <dledford@redhat.com> - 3.0-2
- Add no-strict-aliasing compile flag to silence warnings

* Thu Sep 18 2008 Doug Ledford <dledford@redhat.com> - 3.0-1
- Update to latest upstream version
- Compile three times against the three mpi stacks and make three packages
- Resolves: bz451474

* Mon Jan 22 2007 Doug Ledford <dledford@redhat.com> - 2.0-2
- Recreate lost spec file and patches from memory
- Add dist tag to release
- Turn off FORTIFY_SOURCE when building

